package com.mindoo.xpages.browserlauncher.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IStatusLineManager;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchPartSite;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionDelegate;

import com.ibm.xsp.rcp.XspViewPart;

public class OpenXPageInBrowserAction extends ActionDelegate implements IWorkbenchWindowActionDelegate {
	private IWorkbenchWindow m_window;
	private IAction m_action;

	public void init(IWorkbenchWindow window) {
		m_window=window;
	}

	@Override
	public void dispose() {
		super.dispose();

		m_window=null;
		m_action=null;
	}

	@Override
	public void init(IAction action) {
		super.init(action);

		m_action=action;
	}

	public void logToStatusBar(final String msg) {
		Display.getDefault().asyncExec(new Runnable(){

			public void run() {
				IWorkbenchWindow win = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
				if ( win == null)
					return;

				IWorkbenchPage page = win.getActivePage();
				if (page == null)
					return;

				IWorkbenchPart part = page.getActivePart();
				IWorkbenchPartSite site = part.getSite();

				if (site instanceof IViewSite) {
					IViewSite vSite = ( IViewSite ) site;

					IActionBars actionBars = vSite.getActionBars();

					if(actionBars == null)
						return;

					IStatusLineManager statusLineManager = actionBars.getStatusLineManager();

					if( statusLineManager == null )
						return;

					statusLineManager.setMessage( msg);
				}
			}
		}); 		
	}
	
	@Override
	public void run(IAction action) {
		Display.getDefault().asyncExec(new Runnable() {

			@Override
			public void run() {
				IWorkbenchPart part=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart();
				if (part instanceof XspViewPart) {
					XspViewPart xspPart=(XspViewPart) part;
					String url=xspPart.getBrowserUrl();
					String launchUrl=url;
					int iPos=url.indexOf("SessionID=");
					if (iPos!=-1) {
						int nextDelim=url.indexOf("&", iPos);
						if (nextDelim!=-1) {
							launchUrl=launchUrl.substring(0, nextDelim);
						}
					}
					launchUrl=launchUrl.replace("\\", "%5c");
					logToStatusBar("Launching url in external browser: "+launchUrl);
					Program.launch(launchUrl);
				}
				else {
					MessageDialog.openInformation(null, "No XPage viewpart found", "Please open an XPage in the Notes Client and press this action to launch it in an external browser!");
				}
			}
		});
	}
}
